codeforces 559D Randomizer

题意简述:

在一个格点图中 给定一个凸$n$边形(每个定点均在格点上),随机选择其中一些点构成一个子多边形,

求子多边形的内部点个数的期望。

----------------------------------------------------------------------------------------------------------------------------------

首先这题是需要知道 皮克定理 这个结论的

我们用 $s$代表多边形面积 $ans$代表内部点数(即要求的答案)$node$代表边上的格点

公式即为 $ans=s-\frac{node}{2}+1$

----------------------------------------------------------------------------------------------------------------------------------

然后这题是求期望的 对于期望 我们知道它是满足分配率的 于是我们可以考虑分别求出$s$和$node$的期望

对于$s$的期望 可以这样考虑(算贡献)

每次选出一个子多边形后 剩余部分显然是可以用多个顶点连续的多边形补成的

我们可以用前缀和维护这个顶点连续的多边形的面积 然后来算贡献

公式为$\displaystyle \frac{2^{n-i} -1}{2^n-1-n-C_2^n}*$子多边形面积

直接求出所有是$O(n^2)$的 然而观察公式我们可以发现i取较大的数的时候对答案的影响是很小的

综合考虑题目要求的$10^-9$的相对误差以及$double$的精度 $i$可以取$min(n,60)$

$node$的求法也是类似的 只要熟悉如何算贡献就比较容易了 想了很久还不懂的话可以留言

----------------------------------------------------------------------------------------------------------------------------------

这样我们就可以过掉样例了 然后我们会$ WA 10$

因为$double$不仅仅是精度 还有范围 大概范围就是 $(10^{300}~10^{-300})$

这个问题 初次遇见还是很纠结的 多想想后 我们发现可以把公式变形成这样(上下同时除$2^n$):

$\displaystyle\frac{2^{-i} -1}{1-2^{-n}*(1+n+C_n^2)}*$子多边形面积

----------------------------------------------------------------------------------------------------------------------------------

差不多就是这些了 第一次写$div1D$题 还有些小激动呢

#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
const int N=1e5+10;
double polygon[N],p[N];
int x[N],y[N];
double s,ans,node,product;
int n,lim;
double cross(long long x1,long long y1,long long x2,long long y2)
{
    return x1*y2-x2*y1;
}
int main()
{
    scanf("%d",&n);
    lim=min(n,60);
    p[0]=1;
    for(int i=0;i<n;++i)
    {
        scanf("%d%d",&x[i],&y[i]);
        p[i+1]=p[i]*0.5;
    }
    for(int i=3;i<lim;++i)
    {
        product=(p[i]-p[n])/
            (1-p[n]*((long long)n*(n-1)/2+n+1));
        for(int j=0;j<n;++j)
        {
            polygon[j]+=cross(x[(j+i-2)%n]-x[j],y[(j+i-2)%n]-y[j],
                              x[(j+i-1)%n]-x[j],y[(j+i-1)%n]-y[j]);
            s-=product*polygon[j];
        }
    }
    for(int i=0;i<n-2;++i)
        s+=cross(x[i+1]-x[0],y[i+1]-y[0],
                 x[i+2]-x[0],y[i+2]-y[0]);
    s/=2;
    for(int i=2;i<=lim;++i)
    {
        product=(p[i]-p[n])/
            (1-p[n]*((long long)n*(n-1)/2+n+1));
        for(int j=0;j<n;++j)
            node+=product*__gcd(abs(x[(j+i-1)%n]-x[j]),
                                abs(y[(j+i-1)%n]-y[j]));
    }
    ans=s-node/2+1;
    printf("%.10f\n",ans);
    return 0;
}
时间: 2024-10-12 21:08:18

codeforces 559D Randomizer的相关文章

【codeforces 718E】E. Matvey&#39;s Birthday

题目大意&链接: http://codeforces.com/problemset/problem/718/E 给一个长为n(n<=100 000)的只包含‘a’~‘h’8个字符的字符串s.两个位置i,j(i!=j)存在一条边,当且仅当|i-j|==1或s[i]==s[j].求这个无向图的直径,以及直径数量. 题解:  命题1:任意位置之间距离不会大于15. 证明:对于任意两个位置i,j之间,其所经过每种字符不会超过2个(因为相同字符会连边),所以i,j经过节点至多为16,也就意味着边数至多

Codeforces 124A - The number of positions

题目链接:http://codeforces.com/problemset/problem/124/A Petr stands in line of n people, but he doesn't know exactly which position he occupies. He can say that there are no less than a people standing in front of him and no more than b people standing b

Codeforces 841D Leha and another game about graph - 差分

Leha plays a computer game, where is on each level is given a connected graph with n vertices and m edges. Graph can contain multiple edges, but can not contain self loops. Each vertex has an integer di, which can be equal to 0, 1 or  - 1. To pass th

Codeforces Round #286 (Div. 1) A. Mr. Kitayuta, the Treasure Hunter DP

链接: http://codeforces.com/problemset/problem/506/A 题意: 给出30000个岛,有n个宝石分布在上面,第一步到d位置,每次走的距离与上一步的差距不大于1,问走完一路最多捡到多少块宝石. 题解: 容易想到DP,dp[i][j]表示到达 i 处,现在步长为 j 时最多收集到的财富,转移也不难,cnt[i]表示 i 处的财富. dp[i+step-1] = max(dp[i+step-1],dp[i][j]+cnt[i+step+1]) dp[i+st

Codeforces 772A Voltage Keepsake - 二分答案

You have n devices that you want to use simultaneously. The i-th device uses ai units of power per second. This usage is continuous. That is, in λ seconds, the device will use λ·ai units of power. The i-th device currently has bi units of power store

Educational Codeforces Round 21 G. Anthem of Berland(dp+kmp)

题目链接:Educational Codeforces Round 21 G. Anthem of Berland 题意: 给你两个字符串,第一个字符串包含问号,问号可以变成任意字符串. 问你第一个字符串最多包含多少个第二个字符串. 题解: 考虑dp[i][j],表示当前考虑到第一个串的第i位,已经匹配到第二个字符串的第j位. 这样的话复杂度为26*n*m*O(fail). fail可以用kmp进行预处理,将26个字母全部处理出来,这样复杂度就变成了26*n*m. 状态转移看代码(就是一个kmp

Codeforces Round #408 (Div. 2) B

Description Zane the wizard is going to perform a magic show shuffling the cups. There are n cups, numbered from 1 to n, placed along the x-axis on a table that has m holes on it. More precisely, cup i is on the table at the position x?=?i. The probl

Codeforces 617 E. XOR and Favorite Number

题目链接:http://codeforces.com/problemset/problem/617/E 一看这种区间查询的题目,考虑一下莫队. 如何${O(1)}$的修改和查询呢? 令${f(i,j)}$表示区间${\left [ l,r \right ]}$内数字的异或和. 那么:${f(l,r)=f(1,r)~~xor~~f(1,l-1)=k}$ 记一下前缀异或和即可维护. 1 #include<iostream> 2 #include<cstdio> 3 #include&l

CodeForces - 601A The Two Routes

http://codeforces.com/problemset/problem/601/A 这道题没想过来, 有点脑筋急转弯的感觉了 本质上就是找最短路径 但是卡在不能重复走同一个点 ---->>> 这是来坑人的 因为这是一个完全图(不是被road 连接  就是被rail连接 ) 所以一定有一条直接连1 和 n的路径 那么只用找没有连 1 和 n 的路径的 那个图的最短路即可 然后这个dijkstra写的是O(V^2)的写法 以后尽量用优先队列的写法O(ElogV) 1 #includ